// *******************************************
//	 CLASS: Slide
//	 by Jens Krause [www.websector.de]
// *******************************************

import ascb.util.Proxy;
import mx.transitions.Tween;

import de.websector.games.parachute.slides.SlideButton;
import de.websector.games.parachute.slides.ISlide;
import de.websector.ui.buttons.TextButton;
import de.websector.games.parachute.util.StageCover;

class de.websector.games.parachute.slides.Slide extends MovieClip
{
	private var AUTHOR: String = "Jens Krause [www.websector.de]";
	// mc
	private var mc_target: MovieClip;	
	// vars	
	private var currentSlide: MovieClip; // Slide
	private var slides: Array = [	"menu",
								"level",
								"preGame",
								"help",
								"about",
								"game",
								"gameOver"
							   ];							   
	private var DURATION: Number = .3;
	private var easing: Function = mx.transitions.easing.Regular.easeOut;
	private var show: Boolean;
	private var parentSlide: String;
	private var B_HOVER: Number = 0x619DE3;
	private var B_NORMAL: Number = 0x3B69C2;
	private var START_XPOS: Number;
	private var START_YPOS: Number;
	// instances
	private var b_back : TextButton; // TextButton	 
	private var myCover: StageCover;
	
	function Slide () 
	{
		mc_target = _parent;
		this.onEnterFrame = Proxy.create (this, init); // hack the effect of attachMovie
	};
	///////////////////////////////////////////////////////////
	// init
	///////////////////////////////////////////////////////////	
	public function init (): Void 
	{
		this.onEnterFrame = undefined;
		
		START_XPOS = this._x;
		START_YPOS = this._y;
		
		currentSlide = mc_target["sl_" + slides[0]];
		
		myCover = new StageCover (mc_target, mc_target, false);						
	};
	///////////////////////////////////////////////////////////
	// back button
	///////////////////////////////////////////////////////////		
	private function showBackButton (txtLabel: String): Void 
	{
		var initObj: Object = {	_x: 7, 
								_y: this._y - 20	};
								
		mc_target.attachMovie("b_txt", "b_back", mc_target.getNextHighestDepth(), initObj);
		b_back = mc_target.b_back;
		b_back.init(txtLabel, B_NORMAL, B_HOVER, false);	
	};
	private function hideBackButton (): Void 
	{
		b_back.removeMovieClip();
	};	
	///////////////////////////////////////////////////////////
	// label
	///////////////////////////////////////////////////////////	
	private function changeHeadline (txt: String): Void 
	{
		var h1: TextField = mc_target.h1;
		h1.autoSize = "center";
		h1.htmlText = txt;
		h1.textColor = 0x000000;
		h1._x = Math.round(118 - h1._width / 2);
	};
	///////////////////////////////////////////////////////////
	// tweens
	///////////////////////////////////////////////////////////	
	
	private function move (trigger: MovieClip, ts: String, direction: String): Void 
	{		
		var targetSlide: MovieClip = mc_target["sl_" + ts];
		var startPos1: Number = trigger._x;
		var startPos2: Number = targetSlide._x;
		var endPos1: Number;		
		var endPos2: Number;		
		
		if (direction == "left")
		{
			endPos1 = startPos1 - trigger._width;
			endPos2 = startPos2 - targetSlide._width;
		}
		else
		{
			endPos1 = startPos1 + trigger._width;
			endPos2 = startPos2 + targetSlide._width;		
		}
		
		trigger.myCover.showCover();
		
		trigger.show = false;		
		var tw1: Tween = new Tween (trigger, "_x", easing, startPos1, endPos1, DURATION, true);
		trigger.onStartTween();
		tw1.onMotionFinished = Proxy.create (trigger, trigger.onEndTween);		

		targetSlide.show = true;
		var tw2: Tween = new Tween (targetSlide, "_x", easing, startPos2, endPos2, DURATION, true);
		targetSlide.onStartTween();		
		tw2.onMotionFinished = Proxy.create (targetSlide, targetSlide.onEndTween);	

		currentSlide = targetSlide;	
	};
	private function onEndTween (): Void 
	{
		if (myCover.covered) myCover.removeCover();
	};
	///////////////////////////////////////////////////////////
	// startPositions
	///////////////////////////////////////////////////////////		
	private function startPos (): Void 
	{
		this._x = START_XPOS;
		this._y = START_YPOS;
	};
	
	private function setAllStartPos (): Void 
	{
		for (var i: String in slides)
		{
			var slide: Slide = mc_target["sl_" + slides[i]];
			if (slide != undefined) slide.startPos();			
		}
	};
}